const {
  Property,
  Thing,
  Value,
} = require('webthing');

class WebThingAdd extends Thing {
  constructor(options = {}) {
    super(
      options.name || 'Math: Add',
      ['Thing'],
      options.description || 'Performs an addition of two numbers: A + B = Y'
    );

    this.a = 0;
    this.b = 0;
    this.result = new Value(this.a + this.b);

    this.addProperty(
      new Property(this,
        'a',
        new Value(this.a, this.setA.bind(this)),
        {
          label: 'A',
          type: 'number',
          description: 'First input',
        }
      )
    );

    this.addProperty(
      new Property(this,
        'b',
        new Value(this.b, this.setB.bind(this)),
        {
          label: 'B',
          type: 'number',
          description: 'Second input',
        }
      )
    );

    this.addProperty(
      new Property(this,
        'y',
        this.result,
        {
          label: 'Y',
          type: 'number',
          description: 'The result',
        }
      )
    );
  }

  setA(value) {
    this.a = value;
    this.updateResult();
  }

  setB(value) {
    this.b = value;
    this.updateResult();
  }

  updateResult() {
    this.result.notifyOfExternalUpdate(this.a + this.b);
  }
}

module.exports = WebThingAdd;
